﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using RestSharp;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Text;

namespace NXT_REST_API_samples
{
    class Program // created date: 20160705
    {
        static string username = "<YOUR USERNAME>";
        static string password = "<YOUR PASSWORD>";
        static string folderId = "-1";//"<YOUR FOLDER ID>"; //root folder id: -1
        static string localAsset = "<YOUR LOCAL ASSET LOCATION>"; //"C:\\Users\\FirstName.LastName\\Desktop\\assets\\logo.gif"; // you should replace this field
        static string assetId = "<YOUR ASSET ID>";
        static string assetType = "Asset"; // you could replace this field
        static string adId = "<YOUR AD ID>";

        // four properties below can be retrieved via calling getAd()
        static string adType = "StandardBannerAd"; // you could replace this field
        static string accountId = "<YOUR ACCOUNT ID>";
        static string adFormatId = "<YOUR AD FORMAT ID>";
        static string adDefaultImageType = "AdAsset"; // you could replace this field

        static string advertiserId = "<YOUR ADVERTISER ID>";
        static string brandId = "<YOUR BRAND ID>";
        static string siteId = "<YOUR AD SITE ID>";
        static string campaignId = "<YOUR CAMPAIGN ID>";
        static string placementId = "<YOUR PLACEMENT ID>";
        static string placementType = "InBannerPlacement"; // you could replace this field    

        static string deliveryGroupId = "<YOUR DELIVERY GROUP ID>";
        static string deliveryGroupName = "<YOUR DELIVERY GROUP NAME>";

        static string domain = "https://api.sizmek.com/rest/";
        
        static string sessionId = "";

        static void Main(string[] args) 
        {
            login();

            //createAsset();
            //getAsset();
            //updateAsset();
            //createAssetFolder();
            //getAd();
            //createAd();
            //createAdvertiser();
            //createBrand();
            //createCampaign();
            //createPlacement();
            //assignAdToCampaign();
            //attachAdsToPlacements();
            //getPlacementTag(); // have to wait a bit for the ad to be attached the placement

            //createAdvancedTraffickingCampaign();
            //createPlacement();
            //createDeliveryGroup();
            //attachPlacementsToDeliveryGroups();

            Console.ReadLine();
        }

        public static void login()
        {
            var client = new RestClient(domain + "login/login");
            RestRequest restReq = new RestRequest();
            restReq.Method = Method.POST;

            dynamic loginReq = new System.Dynamic.ExpandoObject();
            loginReq.username = username;
            loginReq.password = password;

            restReq.RequestFormat = DataFormat.Json;
            restReq.AddBody(loginReq);

            RestResponse restRes = (RestResponse)client.Execute(restReq);
            if (restRes.StatusCode.Equals(HttpStatusCode.OK))
            {
                try
                {
                    dynamic loginRes = JObject.Parse(restRes.Content);

                    sessionId = loginRes.result.sessionId;
                    Console.WriteLine("sessionId:"+sessionId);
                }
                catch (Exception e)
                {
                    Console.WriteLine("\nError:" + e.Message);
                }
            }
            else
            {
                Console.WriteLine("login() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
            }
        } // end of login()

        public static void createAsset()
        {
            var client = new RestClient(domain + "assets/files/" + folderId);
            RestRequest restReq = new RestRequest();
            restReq.Method = Method.POST;
            restReq.AddHeader("Authorization", sessionId);
            restReq.AddFile("file", localAsset);

            RestResponse restRes = (RestResponse)client.Execute(restReq);

            if (restRes.StatusCode.Equals(HttpStatusCode.OK))
            {
                try
                {
                    dynamic assetRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("File:" + assetRes.result.id);
                }
                catch (Exception e)
                {
                    Console.WriteLine("\nError:" + e.Message);
                }
            }
            else
            {
                Console.WriteLine("createAsset() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
            }
        } // end of createAsset()

        public static void getAsset()
        {
            var client = new RestClient(domain + "assets/" + assetId);
            RestRequest restReq = new RestRequest();
            restReq.Method = Method.GET;
            restReq.AddHeader("Authorization", sessionId);

            RestResponse restRes = (RestResponse)client.Execute(restReq);

            if (restRes.StatusCode.Equals(HttpStatusCode.OK))
            {
                try
                {
                    dynamic assetRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("type:" + assetRes.result.type);
                }
                catch (Exception e)
                {
                    Console.WriteLine("\nError:" + e.Message);
                }
            }
            else
            {
                Console.WriteLine("getAsset() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
            }
        } // end of getAsset()

        public static void updateAsset()
        {
            try
            {
                dynamic assetReq = new System.Dynamic.ExpandoObject();

                assetReq.entities = new dynamic[1];
                assetReq.entities[0] = new System.Dynamic.ExpandoObject();
                assetReq.entities[0].id = assetId;
                assetReq.entities[0].type = assetType;
                assetReq.entities[0].businessMetadata = new System.Dynamic.ExpandoObject();
                assetReq.entities[0].businessMetadata.displayName = "NewName20170515.gif";
                assetReq.entities[0].businessMetadata.folderId = folderId; // required field, exisiting folder id for new folder id to move
                
                string assetReqJson = JsonConvert.SerializeObject(assetReq);

                RestRequest restReq = new RestRequest();
                restReq.Method = Method.PUT;
                restReq.AddHeader("Authorization", sessionId);
                restReq.AddParameter("application/json", assetReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "assets/" + assetId);

                RestResponse restRes = (RestResponse)client.Execute(restReq);

                if (restRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic assetRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("updateAsset() success");
                }
                else
                {
                    Console.WriteLine("updateAsset() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of updateAssetName()

        public static void createAssetFolder()
        {
            try
            {
                dynamic folderReq = new System.Dynamic.ExpandoObject();

                folderReq.entities = new dynamic[1];
                folderReq.entities[0] = new System.Dynamic.ExpandoObject();
                folderReq.entities[0].type = "AssetFolder";
                folderReq.entities[0].folderType = 0;
                folderReq.entities[0].name = "Newfolder20170515_v2";
                folderReq.entities[0].parentId = "-1";
                folderReq.entities[0].rootParentId = "1";

                string folderReqJson = JsonConvert.SerializeObject(folderReq);
                
                RestRequest restReq = new RestRequest();
                restReq.Method = Method.POST;
                restReq.AddHeader("Authorization", sessionId);
                restReq.AddParameter("application/json", folderReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "assets/folders");
                RestResponse restRes = (RestResponse)client.Execute(restReq);

                if (restRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic folderRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("createAssetFolder() success Folder id:" + folderRes.result.id);
                }
                else
                {
                    Console.WriteLine("createAssetFolder() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createAssetFolder()

        public static void getAd()
        {
            var client = new RestClient(domain + "ads/" + adId);
            RestRequest restReq = new RestRequest();
            restReq.Method = Method.GET;
            restReq.AddHeader("Authorization", sessionId);

            RestResponse restRes = (RestResponse)client.Execute(restReq);

            if (restRes.StatusCode.Equals(HttpStatusCode.OK))
            {
                try
                {
                    dynamic adRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("type:"+adRes.result.type);
                    Console.WriteLine("accountId:"+adRes.result.accountId);
                    Console.WriteLine("adFormatId:"+adRes.result.adFormatId);
                    Console.WriteLine("defaultImage.type:"+adRes.result.defaultImage.type);
                    Console.WriteLine("defaultImage.assetId:"+adRes.result.defaultImage.assetId);
                }
                catch (Exception e)
                {
                    Console.WriteLine("\nError:" + e.Message);
                }
            }
            else
            {
                Console.WriteLine("getAd() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
            }
        } // end of getAd()

        public static void createAd()
        {
            try
            {
                dynamic adReq = new System.Dynamic.ExpandoObject();

                adReq.entities = new dynamic[1];
                adReq.entities[0] = new System.Dynamic.ExpandoObject();
                adReq.entities[0].type = adType;
                adReq.entities[0].name = "Test_" + DateTime.Now;
                adReq.entities[0].accountId = accountId;
                adReq.entities[0].adFormatId = adFormatId;

                adReq.entities[0].defaultImage = new System.Dynamic.ExpandoObject();
                adReq.entities[0].defaultImage.type = adDefaultImageType;
                adReq.entities[0].defaultImage.assetId = assetId;

                string adReqJson = JsonConvert.SerializeObject(adReq);

                RestRequest restReq = new RestRequest();
                restReq.Method = Method.POST;
                restReq.AddHeader("Authorization", sessionId);
                restReq.AddParameter("application/json", adReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "ads/");
                RestResponse restRes = (RestResponse)client.Execute(restReq);

                if (restRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic adRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("createAd() success Ad id:" + adRes.result[0].id);
                }
                else
                {
                    Console.WriteLine("createAd() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createAd()

        public static void createAdvertiser()
        {
            try
            {
                dynamic advReq = new System.Dynamic.ExpandoObject();

                advReq.entities = new dynamic[1];
                advReq.entities[0] = new System.Dynamic.ExpandoObject();
                advReq.entities[0].type = "Advertiser";
                advReq.entities[0].name = "Test_" + DateTime.Now;
                advReq.entities[0].accountId = accountId;
                advReq.entities[0].vertical = "Apparel";

                string advReqJson = JsonConvert.SerializeObject(advReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", advReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "advertisers/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic advRes = JObject.Parse(restCreateRes.Content);
                    Console.WriteLine("createAdv() success Adv id:" + advRes.result.id);
                }
                else
                {
                    Console.WriteLine("createAdv() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createAdvertiser()

        public static void createBrand()
        {
            try
            {
                dynamic advReq = new System.Dynamic.ExpandoObject();

                advReq.entities = new dynamic[1];
                advReq.entities[0] = new System.Dynamic.ExpandoObject();
                advReq.entities[0].type = "Brand";
                advReq.entities[0].name = "Test_" + DateTime.Now;
                advReq.entities[0].advertiserId = advertiserId;

                string advReqJson = JsonConvert.SerializeObject(advReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", advReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "brands/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic advRes = JObject.Parse(restCreateRes.Content);
                    Console.WriteLine("createBrand() success Brand id:" + advRes.result.id);
                }
                else
                {
                    Console.WriteLine("createBrand() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createBrand()

        public static void createCampaign()
        {
            try
            {
                dynamic cmpReq = new System.Dynamic.ExpandoObject();

                cmpReq.entities = new dynamic[1];
                cmpReq.entities[0] = new System.Dynamic.ExpandoObject();
                cmpReq.entities[0].type = "Campaign";
                cmpReq.entities[0].name = "Test_" + DateTime.Now;
                cmpReq.entities[0].brandId = brandId;

                cmpReq.entities[0].adminSettings = new System.Dynamic.ExpandoObject();
                cmpReq.entities[0].adminSettings.type = "AdminSettings";
                cmpReq.entities[0].adminSettings.campaignSettings = new System.Dynamic.ExpandoObject();
                cmpReq.entities[0].adminSettings.campaignSettings.type = "CampaignSettings";
                cmpReq.entities[0].adminSettings.campaignSettings.traffickingMode = "SimpleMode";

                string cmpReqJson = JsonConvert.SerializeObject(cmpReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", cmpReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "campaigns/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic cmpCreateRes = JObject.Parse(restCreateRes.Content);

                    Console.WriteLine("createCampaign() success Campaign  id:" + cmpCreateRes.result.id);
                }
                else
                {
                    Console.WriteLine("createCampaign() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }

        } // end of createCampaign()

        public static void createPlacement()
        {
            try
            {
                dynamic plcReq = new System.Dynamic.ExpandoObject();

                plcReq.entities = new dynamic[1];
                plcReq.entities[0] = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].type = "InBannerPlacement"; // sub class type
                plcReq.entities[0].placementType = "IN_BANNER";
                plcReq.entities[0].name = "Test_" + DateTime.Now;

                //doc lists as optional fields
                plcReq.entities[0].campaignId = campaignId;
                plcReq.entities[0].siteId = siteId;
                plcReq.entities[0].status = "New";

                plcReq.entities[0].bannerSize = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].bannerSize.type = "APIBannerSize";
                plcReq.entities[0].bannerSize.width = "300";
                plcReq.entities[0].bannerSize.height = "250";

                plcReq.entities[0].servingAndCostData = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].servingAndCostData.mediaServingData = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].servingAndCostData.mediaServingData.startDate = "1458187200000";
                plcReq.entities[0].servingAndCostData.mediaServingData.endDate = "1458878399999";
                plcReq.entities[0].servingAndCostData.mediaServingData.hardStopMethod = "KEEP_SERVING_AS_USUAL";

                plcReq.entities[0].servingAndCostData.mediaCostData = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].servingAndCostData.mediaCostData.type = "MediaCost";
                plcReq.entities[0].servingAndCostData.placementLevel = true;

                plcReq.entities[0].tagBuilderParams = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].tagBuilderParams.type = "TagBuilderParams";

                plcReq.entities[0].tagBuilderParams.siteServing = new System.Dynamic.ExpandoObject();
                plcReq.entities[0].tagBuilderParams.siteServing.secureServingProtocol = "HTTP";

                string plcReqJson = JsonConvert.SerializeObject(plcReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", plcReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "placements/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic plcCreateRes = JObject.Parse(restCreateRes.Content);

                    Console.WriteLine("createAd() success Placement id:" + plcCreateRes.result[0].id);
                }
                else
                {
                    Console.WriteLine("createPlacement() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createPlacement()

        public static void assignAdToCampaign()
        {
            try
            {
                dynamic adReq = new System.Dynamic.ExpandoObject();

                adReq.assignedEntityType = "Campaign";
                adReq.entityIds = new dynamic[1];
                adReq.entityIds[0] = campaignId;
                adReq.adIds = new dynamic[1];
                adReq.adIds[0] = adId;

                string adReqJson = JsonConvert.SerializeObject(adReq);
                
                RestRequest restReq = new RestRequest();
                restReq.Method = Method.POST;
                restReq.AddHeader("Authorization", sessionId);
                restReq.AddParameter("application/json", adReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "ads/assignMasterAd/");

                RestResponse restRes = (RestResponse)client.Execute(restReq);

                if (restRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic adRes = JObject.Parse(restRes.Content);
                    Console.WriteLine("assignAdToCampaign() success");
                }
                else
                {
                    Console.WriteLine("assignAdToCampaign() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }

        } // end of assignAdToCampaign()

        public static void attachAdsToPlacements()
        {
            try
            {
                dynamic adReq = new System.Dynamic.ExpandoObject();

                adReq.entities = new dynamic[1];
                adReq.entities[0] = new System.Dynamic.ExpandoObject();
                adReq.entities[0].type = placementType;
                adReq.entities[0].id = placementId;

                adReq.entities[0].adsToAttach = new dynamic[1];
                adReq.entities[0].adsToAttach[0] = new System.Dynamic.ExpandoObject();
                adReq.entities[0].adsToAttach[0].type = adType;
                adReq.entities[0].adsToAttach[0].id = adId;
                adReq.entities[0].adsToAttach[0].enabled = true;

                string adReqJson = JsonConvert.SerializeObject(adReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.PUT;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", adReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "deliveryGroups/attachAdsToPlacements/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    Console.WriteLine("attachAdsToPlacements() success:\n");
                }
                else
                {
                    Console.WriteLine("attachAdsToPlacements() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of attachAdsToPlacements()

        public static void getPlacementTag()
        {
            try
            {
                dynamic plcTagReq = new System.Dynamic.ExpandoObject();

                plcTagReq.entities = new dynamic[1];
                plcTagReq.entities[0] = new System.Dynamic.ExpandoObject();

                plcTagReq.entities[0].type = "TagRequest";
                plcTagReq.entities[0].campaignId = campaignId;

                plcTagReq.entities[0].placementsIds = new dynamic[1];
                plcTagReq.entities[0].placementsIds[0] = placementId;

                string plcTagReqJson = JsonConvert.SerializeObject(plcTagReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", plcTagReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "placements/generateTag/");
                RestResponse restRes = (RestResponse)client.Execute(restCreateReq);

                if (restRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic tagRes = JObject.Parse(restRes.Content);

                    Console.WriteLine("getPlacementTag() success. Tag:\n" + tagRes.result[0].tag);
                }
                else
                {
                    Console.WriteLine("getPlacementTag() fail:\n" + restRes.StatusCode + "==>" + restRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }

        } // end of getPlacementTag()

        public static void createAdvancedTraffickingCampaign()
        {
            try
            {
                dynamic cmpReq = new System.Dynamic.ExpandoObject();

                cmpReq.entities = new dynamic[1];
                cmpReq.entities[0] = new System.Dynamic.ExpandoObject();
                cmpReq.entities[0].type = "Campaign";
                cmpReq.entities[0].name = "Test_" + DateTime.Now;
                cmpReq.entities[0].brandId = brandId;

                cmpReq.entities[0].adminSettings = new System.Dynamic.ExpandoObject();
                cmpReq.entities[0].adminSettings.type = "AdminSettings";
                cmpReq.entities[0].adminSettings.campaignSettings = new System.Dynamic.ExpandoObject();
                cmpReq.entities[0].adminSettings.campaignSettings.type = "CampaignSettings";
                //cmpReq.entities[0].adminSettings.campaignSettings.traffickingMode = "SimpleMode";

                string cmpReqJson = JsonConvert.SerializeObject(cmpReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", cmpReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "campaigns/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic cmpCreateRes = JObject.Parse(restCreateRes.Content);

                    Console.WriteLine("createAdvancedTraffickingCampaign() success Campaign  id:" + cmpCreateRes.result.id);
                }
                else
                {
                    Console.WriteLine("createAdvancedTraffickingCampaign() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createAdvancedTraffickingCampaign()    

        public static void createDeliveryGroup()
        {
            try
            {
                dynamic dgReq = new System.Dynamic.ExpandoObject();

                dgReq.entities = new dynamic[1];
                dgReq.entities[0] = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].type = "DeliveryGroup";
                dgReq.entities[0].name = "DG_" + DateTime.Now;
                dgReq.entities[0].campaignId = campaignId;

                dgReq.entities[0].rootContainer = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].rootContainer.type = "RootContainer";
                dgReq.entities[0].rootContainer.subContainers = new dynamic[1];
                dgReq.entities[0].rootContainer.subContainers[0] = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].rootContainer.subContainers[0].type = "DeliveryGroupAd";
                dgReq.entities[0].rootContainer.subContainers[0].masterAdId = adId;
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting.type = "EvenDistribution";
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting.enabled = true; //optional, but have to populate or an error will throw at attaching
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting.weight = 100; //optional, but have to populate or an error will throw at attaching

                dgReq.entities[0].servingSetting = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].servingSetting.type = "APIServingSetting";
                dgReq.entities[0].servingSetting.serveDefaultImage = true;

                string dgReqJson = JsonConvert.SerializeObject(dgReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.POST;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", dgReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "deliveryGroups");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    dynamic dgCreateRes = JObject.Parse(restCreateRes.Content);

                    Console.WriteLine("createDeliveryGroup() success Delivery Group id:" + dgCreateRes.result[0].id);
                }
                else
                {
                    Console.WriteLine("createDeliveryGroup() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of createDeliveryGroup()   

        public static void attachPlacementsToDeliveryGroups()
        {
            try
            {
                dynamic dgReq = new System.Dynamic.ExpandoObject();

                dgReq.entities = new dynamic[1];
                dgReq.entities[0] = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].type = "DeliveryGroup";
                dgReq.entities[0].id = deliveryGroupId;

                dgReq.entities[0].placements = new dynamic[1];
                dgReq.entities[0].placements[0] = placementId;
                dgReq.entities[0].campaignId = campaignId;
                dgReq.entities[0].name = deliveryGroupName;
                dgReq.entities[0].isSelected = true; //optional
                dgReq.entities[0].rootContainer = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].rootContainer.type = "RootContainer";
                dgReq.entities[0].rootContainer.subContainers = new dynamic[1];
                dgReq.entities[0].rootContainer.subContainers[0] = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].rootContainer.subContainers[0].type = "DeliveryGroupAd";
                dgReq.entities[0].rootContainer.subContainers[0].masterAdId = adId;
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting.enabled = true;
                dgReq.entities[0].rootContainer.subContainers[0].rotationSetting.type = "EvenDistribution";

                dgReq.entities[0].servingSetting = new System.Dynamic.ExpandoObject();
                dgReq.entities[0].servingSetting.type = "APIServingSetting";
                dgReq.entities[0].servingSetting.serveDefaultImage = true;

                string adReqJson = JsonConvert.SerializeObject(dgReq);

                RestRequest restCreateReq = new RestRequest();
                restCreateReq.Method = Method.PUT;
                restCreateReq.AddHeader("Authorization", sessionId);
                restCreateReq.AddParameter("application/json", adReqJson, ParameterType.RequestBody);

                var client = new RestClient(domain + "deliveryGroups/attachPlacementsToDeliveryGroups/");
                RestResponse restCreateRes = (RestResponse)client.Execute(restCreateReq);

                if (restCreateRes.StatusCode.Equals(HttpStatusCode.OK))
                {
                    Console.WriteLine("attachPlacementsToDeliveryGroups() success:\n");
                }
                else
                {
                    Console.WriteLine("attachPlacementsToDeliveryGroups() fail:\n" + restCreateRes.StatusCode + "==>" + restCreateRes.Content);
                }
            }
            catch (Exception e)
            {
                Console.WriteLine("\nError:" + e.Message);
            }
        } // end of attachPlacementsToDeliveryGroups()
    }
}
